#define FILETIME_CPP
#include <sys/time.h>
#include "FileTime.h"
#include <iostream>
//calcul du temps
double gettime() {
	struct timeval tmp2 ;
	gettimeofday (&tmp2, 0) ;
	return (double) tmp2.tv_sec + ((double) tmp2.tv_usec) * 1e-6;
}


// Boucles de ralentissement
void  TimeLoopFn(unsigned int* x, unsigned int *y) 
   { //std::cout << "testing2..." << std::endl; 
     unsigned int* ptx = x ;
     unsigned int* pty = y ;  
     int cont = 1;   
     for (int i= 0 ; cont != 0 ; i++) {
       for (int j= 0;  j < TIMEMAX ; j++) {
        *ptx = (*pty % (*pty+1)) % (*ptx+1) ;
	if (i*TIMEMAX+j > TIMEMAX*TIMEMAX) { 
	  cont = 0; 
	  break;
	}
       }
      }
};

void init_timeloop(double milliseconds_comp) {
  if (milliseconds_comp <= 0) 
   {
    TIMEMAX = 0 ;
   }
  else
   {  
      //NB le temps ecoule evolue comme TIMEMAX^2 
      //double sqrt_10 = 3.16227766 ; 
      //unsigned int i = 17 ; 
      /* Pour une calibration automatique 
        TIMEMAX = 1003.16227766;  // pour 0.1s a priori
        double time = gettime(); // Starts timer
        TimeLoop( i ) ; 
        time = 1000*(gettime() - time) ; 
        TIMEMAX = milliseconds_comp / time * TIMEMAX ;
       */
      // Calibration a la main ...
        TIMEMAX = milliseconds_comp * 1000 ;
      //std::cerr << "TIMEMAX :" << TIMEMAX << endl ;
   } 
}; 
