/***************************************************************************
 *   Copyright (C) 2005 by Davide Vernizzi                                 *
 *   vernizzi@imag.fr                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream>
#include <fstream>
#include <cstdlib>

using namespace std;


class fileIO {
public:
	int read (char* fileName, int avg) {
		ifstream inputFile(fileName, ios::binary);
		int i = 0;
		double k = 0;
		double res = 0;
		double min = 99999;
		double max = -99999;
		
		
		// File opening
		if (!inputFile) {
			cout << "Error opening input file" << endl;
			return -1;
		}
		
		while (inputFile.good()){ 
			inputFile>>k;
			if (k<min)
				min = k;
			if (k>max)
				max = k;
			res+=k;
			i++;
		}
		k = res / i;
		if (!avg)
			cout << k << " regular average" << endl;
                if(i > 2){
       		k = res - min - max;
		k = k/(i-2);
		}
		
		if (avg)
			cout << k << " " << max << " " << min << endl;
		
		inputFile.close();
		
		return 0;
	}
};

/*
Main of the program
*/
int main(int argc,char* argv[]) {
	
	fileIO f;
	
	f.read(argv[1], atoi(argv[2]));
}
